#include <Wire.h>
#include <Adafruit_NeoPixel.h>
#ifdef __AVR__
#include <avr/power.h>
#endif

#define PIN 6

// Parameter 1 = number of pixels in strip
// Parameter 2 = Arduino pin number (most are valid)
// Parameter 3 = pixel type flags, add together as needed:
//   NEO_KHZ800  800 KHz bitstream (most NeoPixel products w/WS2812 LEDs)
Adafruit_NeoPixel strip = Adafruit_NeoPixel(30, PIN, NEO_GRB + NEO_KHZ800);

// IMPORTANT: To reduce NeoPixel burnout risk, add 1000 uF capacitor across
// pixel power leads, add 300 - 500 Ohm resistor on first pixel's data input
// and minimize distance between Arduino and first pixel.  Avoid connecting
// on a live circuit...if you must, connect GND first.

int x = 0;

void setup() {

  //The next couple of lines are in charge of reading information about the pulse of the driver
  // Start the I2C Bus as Slave on address 1
  Wire.begin(1); 
  
  strip.begin();
  strip.show(); // Initialize all pixels to 'off'
}

void loop(){
  
  Wire.onReceive(receiveEvent);
  int HR = x;
  
  if (HR<71 && HR>0){
    LowRate(25);    //Whatever this is causing the function to take a long time
  }
  
  else if (70<HR && HR<91){    
    colorWipe(strip.Color(0, 255, 234), 10);
    colorWipe(strip.Color(0, 0, 0), 5);
    colorWipe(strip.Color(0, 255, 234), 10);
    colorWipe(strip.Color(0, 0, 0), 5);
  }
  
  else if (90<HR && HR<111){    
    rainbowCycle1(5);
  }
  
  else if (110<HR && HR<131){    
    ProgramX(1);
  }
  
  else if (130<HR && HR<151){
    theaterChaseRainbow(25);   
   }
   
  else if (150<HR && HR<171){    
    colorWipe(strip.Color(198, 255, 0), 25);
    colorWipe(strip.Color(0, 0, 0), 25);
    colorWipeReverse(strip.Color(198, 255, 0), 25);
    colorWipeReverse(strip.Color(0, 0, 0), 25);
   }
   
  else if (HR > 171){
    rainbowCycle(.01);
  }
  
  else{
    colorWipe(strip.Color(255, 255, 255), 50);
    colorWipe(strip.Color(0, 0, 0), 50);
  }
}
